//             TECHNOLOGICAL ARTS
//              +1(416) 963-8996 
//	        www.technologicalarts.ca
#include <hidef.h>           /* common defines and macros */
#include <mc9s12dp512.h>     /* derivative information */
#include "STEPPER.h"

//Initialise Board 
//*********************
void stepper_init(void)
//*********************
{
  Delay(100000);          // Delay on start up
  PLL_Init();
  PORT_Init();
  ModulusDown_Init();
}


// Initailise PORT's  
//***************************************************
void PLL_Init(void)
//***************************************************
{
  SYNR=0x02;     	// PLLCLK=2*OCSCLK*(SYNR+1)/(REDV+1)
  
  REFDV=0x01;    	// SYNR=2, REFDV=1 gives PLLOSC= 48MHz
  
  CLKSEL=0x00;   	// WAIT FOR TO SWITCH PLLCLK
  
  PLLCTL=0xD1;   	// ENABLE CLOCK MONITOR, ON PLL, SELECT HIGH BANDWIDTH 
                	// FILTER, SELF CLOCK MODE 
 
  while(CRGFLG_LOCK==0); // wait to stabilize the clock 
  
  CLKSEL=0x80;   	// SET SYSTEM CLOCK TO PLL
} 
// PLL_Init();


// ******************
//  Initialise PORT
// ******************
 void PORT_Init(void)
{
  DDRT|=0xFE;             // Initialise port
  DDRB=0xFF;
}
// PORT_Init();


//********************************
void Delay(unsigned long constant) 
//********************************
{
  volatile unsigned long counter;  
  for(counter=constant;counter>0;counter--);
}


//***************************************************
void ModulusDown_Init(void)
//***************************************************
{
 MCCTL=0xC7;    // enable modulus down counter and set 
	              // prescaler to 1
 MCCNT=DELAY;   // set count to 20000
 MCFLG=0x80;    //clear Modulus Down Counter Under Flow Flag
}

//Reset Board
//**************
void Reset(void)
//**************
{
  PTT_PTT4=0;
  Delay(1000);
  PTT_PTT4=1;

}
//Syncronise Steps
//****************
void Sync(void)
//****************
{
  PTT_PTT1=0;
  Delay(1000);
  PTT_PTT1=1;

}

//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
// This is interrupt subroutine for Modulus Down Counter Interrupt
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#pragma CODE_SEG __NEAR_SEG NON_BANKED
interrupt void ModulusDown_ISR(void)
 {
	MCFLG = 0x80;   		  // clear flag 
  PTT_PTT6=~PTT_PTT6;   // generate clock pulse on PTT6
 }
#pragma CODE_SEG DEFAULT
