//             TECHNOLOGICAL ARTS
//              +1(416) 963-8996 
//	        www.technologicalarts.ca
// This program demonstrates using the Unipolar/Bipolar Motor Board with the Adapt9S12DP512 board.
//

// Here are the pin connections to make between Adapt9S12DP512 and the Unipolar/Bipolar Motor Board.

//   Pinout Motor Board           H1 Connector/PORT T
//        1.HOME                       13/PT0
//        2.SYNC                       12/PT1
//        3.ENABLE                     11/PT2
//        4.CONTROL                    10/PT3
//        5.RESET                       9/PT4
//        6.HALF/FULL_L                 8/PT5
//        7.STEP                        7/PT6
//        8.DIR                         6/PT7

// You can use our standard functions by including file STEPPER.c and STEPPER.h in your project.
// The functions are explained below:

// Speed(x); where x is speed, 1<x<65535 but if you use a speed below 1000, the stepper motor
//           starts to skip steps and may not even rotate.  It depends on the characteristics of the motor you are using.

// Reset(); Reset Board
// Sync();  Synchronise the stepping
// Direction(x); where x = FORWARD or REVERSE
// Step(x); where x =FULL or HALF
// Enable(); enable control circuit
// Disable(); Disable control circuit


#include <hidef.h>      /* common defines and macros */
#include <mc9s12dp512.h>     /* derivative information */
#include "STEPPER.h"
#pragma LINK_INFO DERIVATIVE "mc9s12dp512"

void main(void) 
{
  stepper_init();
  EnableInterrupts;
  
  Reset();  //Reset Stepper motor board
  Enable(); // Enable Output
  Sync();   // Synchronise with clock
  for(;;) 
  {
  Delay(delay);
  Step(HALF);
  Direction(FORWARD);
  PORTB=0xFF;
  Speed(3000);
  Delay(delay);
  Direction(REVERSE);
  PORTB=0xAA;
  Step(HALF);
  Speed(1500);
 
  
  } /* wait forever */
  /* please make sure that you never leave this function */
}
